package AccountManager::AuthenticationToken;

use strict;
use warnings;

use base 'AccountManager::DB::Object';

__PACKAGE__->meta->setup(
    table   => 'authenticationtokens',

    columns => [
        id            => { type => 'bigserial', not_null => 1 },
        token         => { type => 'varchar', length => 50, not_null => 1 },
        email_address => { type => 'varchar', length => 200, not_null => 1 },
        sp_entityid   => { type => 'varchar', length => 200, not_null => 1 },
        creation_date => { type => 'date' },
    ],

    primary_key_columns => [ 'id' ],

    unique_keys => [
        [ 'token' ],
        [ 'email_address', 'sp_entityid' ],
    ],
);

sub print {
    my ($self, $fd) = @_;
    $fd = \*STDOUT unless $fd;

    printf $fd
"AuthenticationToken ID=%s; token=%s; email_address=%s; sp_entityid=%s; creation_date=%s\n",
      $self->id(), $self->token(), $self->email_address(),
      $self->sp_entityid(),
      $self->creation_date()->strftime('%Y:%m:%d');
}

1;
